+ first=$1; shift
+ second=$1; shift
+ keepfirst=
+ ignorespace=
+ label=test
+ while [ $# -gt 0 ]; do
+ case $1 in
+ 'keep first') keepfirst=1 ;;
+ 'ignore space') ignorespace=1 ;;
+ ':') shift; label=\'"$*"\'; break ;;
+ *) echo "$0: invalid check() argument \"$1\" in test suite" >&2 ;;
+ esac
+ shift
+ done
+
+ success=
+ if [ "$ignorespace" ]; then
+ #### POSIX diff should support -b.
+ prepare_space <"$second" | diff -b "$first" - >/dev/null && success=1
+ else
+ cmp -s "$first" "$second" && success=1
+ fi
+
+ if [ "$success" ]; then
+ [ "$keepfirst" ] || rm -f "$first"
+ rm -f "$second"
+ else
+ echo
+ #### POSIX diff should support -c.
+ diff -c "$first" "$second" || true
+ echo
+ echo "$0: $label failed, outputs are in $first and $second."
+ failed=`expr ${failed:-0} + 1`
+ #### Set return status of the function.
+ [ $failed -eq 0 ]
+ fi
+}
+
+
+#### Shortcut to enable use of valgrind: set NMH_VALGRIND environment
+#### variable (to anything) so run_* will use valgrind.
+if [ "${NMH_VALGRIND}" -a -z "${NMH_TEST_PREFIX}" ]; then
+ #### Need absolute path to valgrind.supp in case the test does a cd.
+ NMH_TEST_PREFIX="valgrind --quiet --error-exitcode=1 \
+ --suppressions=`cd ${srcdir} && pwd`/test/valgrind.supp"
+fi
+
+#### Run test under another program by setting NMH_TEST_PREFIX
+#### environment variable to, e.g., 'valgrind --quiet'.
+run_prog() {
+ case $1 in
+ #### Don't run valgrind on shell built-in.
+ eval\ *) "$@" ;;
+ *) ${NMH_TEST_PREFIX} "$@" ;;
+ esac
+}
+
+
+#### run_test() requires two arguments, the first is a program and
+#### arguments, the second is its expected one-line output string.
+#### If the actual output does not match that string:
+#### an error message is printed and global variable "failed" is incremented;
+#### if there is an optional third argument, it is used in the error message.
+run_test() {
+ set +e
+ case $1 in
+ #### Don't run valgrind on shell built-in.
+ eval\ *) actual_output=`$1 2>&1` ;;
+ *) actual_output=`${NMH_TEST_PREFIX} $1 2>&1` ;;
+ esac
+ set -e
+ if test x"$actual_output" != x"$2"; then
+ echo "$0: ${3:-\"$1\"} expected:" 1>&2
+ echo " '$2'" 1>&2
+ echo "but instead got:" 1>&2
+ echo " '$actual_output'" 1>&2
+ failed=`expr ${failed:-0} + 1`
+ fi
+}
+
+#### Function invoked by trap on exit.
+cleanup() {
+ #### Save exit status to use as status for this program.
+ status=$?
+
+ #### Clean up test mail space.
+ #### cd to $MH_TEST_DIR before trying to remove its Mail
+ #### subdirectory. rm on Solaris won't remove it if it's in the
+ #### path of the current working directory.
+ test -z "$MH_TEST_NOCLEANUP" && (cd $MH_TEST_DIR; rm -rf "$MH_TEST_DIR"/Mail)
+
+ #### Report test name if set, which indicates failure.
+ #### Relies on set -e to invoke the trap which calls
+ #### this function on failure.
+ #### To use:
+ #### 1) Set test name before running the test, use start_test().
+ #### 2) Unset upon successful completion, use finish_test().
+ if test -n "$nmh_tests_testname"; then
+ echo $nmh_tests_testname failed
+ fi
+
+ #### Exit with non-zero status if failure. Failure is defined as either
+ #### non-empty nmh_tests_testname or non-zero exit status on entry to the
+ #### function.
+ if test -n "$nmh_tests_testname" -o $status -ne 0; then
+ test $status -ne 0 && exit $status || exit 1
+ test $status -ne 0 && exit 0 || exit 0
+ fi
+}
+
+#### Function to set the test name, and whatever the future brings.
+start_test() {
+ #### run_test disables exit on non-zero status, but does increment
+ #### failed. Don't overwrite nmh_tests_testname if there was a
+ #### failure; remember the first test that failed.
+ [ ${failed:-0} -eq 0 ] && nmh_tests_testname="$1"
+}
+
+#### Corresponding function to indicate that the test has finished. It need
+#### not be called after each test, just the last one in a file.
+finish_test() {
+ #### run_test disables exit on non-zero status, but does increment
+ #### failed. Don't unset nmh_tests_testname if there was a failure.
+ [ ${failed:-0} -eq 0 ] && unset nmh_tests_testname